## Filesystem Hierarchy Standard
PsychOS is not a UNIX system, nor does it try to be. It doesn't have a 'real' VFS and doesn't have a devfs. As such, the filesystem is arranged differently.

### Top level filesystems.
Filesystems devices are represented as top-level directories, eg /boot, /tmp, /fs01.  
The mount points are strings, and can be of arbitrary length. However, it is recommended to keep them under 20 characters, and to not have spaces, or special characters in them.  
A device can be mounted multiple times under multiple names.

### /boot
/boot is the device the system booted from, and may be the same as /tmp under some circumstances. It contains all the special directories needed for the system to function.
#### /boot/exec
exec contains executable programs and utilities, generally separate from the kernel.
#### /boot/lib
lib contains all the libraries used by the system.
#### /boot/doc
doc contains the documentation, though it may not exist if the documentation isn't neccesary.
#### /boot/sys
sys contains miscellaneous system files like the user database and autorun scripts.
